package hf.spaceinvaders.model;

import java.util.List;
import java.util.Random;

public class Alien extends Sprite {

    private enum Colors {
        blue,
        green,
        purple,
        red,
        white,
        yellow
    }
    private int tickCount = 0;
    public static int tickSlower = 50;
    public static int statVelocity;

    /**
     * létrehozza az alien-t
     * a paraméterként kapott adatokkal,
     * valamint alap értékekkel
     * random generálja az alien-ek színét,
     * majd betölti a képet
     * @param x
     * @param y
     * @param hp
     * @param lvl
     */
    public Alien(double x, double y, int hp, int lvl) {
        super(x, y);
        health = hp;
        level = lvl;
        String filename = "monster";
        String directory;
        velocity = 5; //for the game: 2
        statVelocity = velocity;
        sizeX = 50;
        sizeY = 50;

        Random rand = new Random();

        Colors[] colors = Colors.values();
        int colorindex = rand.nextInt(colors.length);;

        if (level >= 1 && level <= 4){
            filename += level;
        } else {
            filename += "1";
        }

        directory = filename;
        directory += "/";

        filename += "_";
        filename += colors[colorindex];
        filename += ".png";

        loadImage("/images/" + directory + filename);
    }

    /**
     * beállítja az alien pozícióját
     * ha az alien leér a pálya aljára, 
     * leállítja a játékot
     * kezeli, ha meg kell haljon
     * növeli a tick-számlálót
     * @param sprites
     * @param gameOver
     */
    @Override
    public void tick(List<Sprite> sprites, Runnable gameOver) {

        if ((tickCount % tickSlower) == 0){
            position.setY(position.getY() + getStatVelocity());
        }
        
        if (position.getY() >= 600 - this.sizeY){
            gameOver.run();
        }

        if (shouldDie()){
            sprites.remove(this);
        }
        
        tickCount++;
    }
    
    /** getters for testing **/
    /** autogenerated with intellij **/

    public static int getStatVelocity() {
        return statVelocity;
    }

    public static void setStatVelocity(int statVelocity) {
        Alien.statVelocity = statVelocity;
    }

    public static int getTickSlower() {
        return tickSlower;
    }

    public static void setTickSlower(int tickSlower) {
        Alien.tickSlower = tickSlower;
    }
}